package com {
	import com.Prepend;

	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.xml.XMLDocument;	

	public class Model extends EventDispatcher {
		//singleton controls
		public static const instance : Model = new Model(SingletonLock);
		public var ready : Boolean = false;
		private var loader : URLLoader;
		private var dataXML : XML;

		private var docXML : XMLDocument;

		public function Model(lock : Class) {
			if (lock != SingletonLock) {
				throw new Error("Invalid Singleton Access. Use Model.instance");
			}
		}
		
		public function init(_xmlPath : String) : void {
			loadXML(_xmlPath);
		}

		private function loadXML(_xmlPath : String) : void {
			loader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, xmlLoadComplete);
			loader.load(new URLRequest(Prepend.baseUrl + _xmlPath));
		}

		private function xmlLoadComplete(e : Event) : void {
			trace("xml load complete");
			var _xml:String = String(loader.data);
			_xml.replace("\n", "");
			_xml.replace("\r", "");
			_xml.replace("\t", "");
			//trace("_xml: " + _xml);
			//dataXML = XML(loader.data);
			dataXML = new XML(_xml);
			ready = true;
			instance.dispatchEvent(new Event("XMLLoadComplete"));
		}

		public function getContent() : XMLList {
			//return dataXML.content.page;
			return dataXML.page;
		}
	}
}

class SingletonLock {
}
