/*
Copyright (c) 2008, Andy Dremeaux
All rights reserved.

Licensed under the BSD license.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of
    conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of
    conditions and the following disclaimer in the documentation and/or other materials
    provided with the distribution.
    * Neither the name of the Andy Dremeaux nor the names of its contributors may be used
    to endorse or promote products derived from this software without specific prior written
    permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package com {

	import flash.display.DisplayObject;
		
	/**
	* @author Andy Dremeaux
	*/
	public class Prepend
	{		
		public static var baseUrl:String;
		public static var modifiedUrl:String;
		
		public static function init( _displayObject:DisplayObject ):void {
			if (baseUrl) return;
			
			var u:String =  _displayObject.root.loaderInfo.url;
			u = u.substr(0, u.lastIndexOf("?"));  			// slashes in the args would screw up without this
			
			baseUrl = u.substr(0, u.lastIndexOf("/")) + "/";
			//trace('baseUrl: ' + (baseUrl));	
			modifiedUrl = baseUrl.substr(0,baseUrl.length-1); 
			modifiedUrl = modifiedUrl.substr(0, modifiedUrl.lastIndexOf("/")) + "/";
		}
	}
	
}
